Index: palm/trunk/SOURCE/advec_s_bc.f90
===================================================================
--- palm/trunk/SOURCE/advec_s_bc.f90	(revision 1516)
+++ palm/trunk/SOURCE/advec_s_bc.f90	(revision 1517)
@@ -920,373 +965,341 @@
           ENDDO
 
-       ELSE
-!
-!--       Neumann: dzu(nzt+2:3) are not defined, dzu(nzt+1) is used instead
+       ELSEIF ( sk_char == 'nr' )  THEN
+
+!
+!--       Rain drop concentration boundary condition at the bottom boundary:
+!--       Dirichlet (fixed surface rain drop concentration).
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                sk_p(nzt+2,j,i)   = sk_p(nzt+1,j,i) + bc_q_t_val * dzu(nzt+1)
-                sk_p(nzt+3,j,i)   = sk_p(nzt+2,j,i) + bc_q_t_val * dzu(nzt+1)
-             ENDDO
-          ENDDO
-
+                sk_p(nzb,j,i)   = sk_p(nzb+1,j,i)
+                sk_p(nzb-1,j,i) = sk_p(nzb,j,i)
+                sk_p(nzb-2,j,i) = sk_p(nzb,j,i)
+             ENDDO
+          ENDDO
+
+!
+!--       Rain drop concentration boundary condition at the top boundary: Dirichlet
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                sk_p(nzt+2,j,i)   = sk_p(nzt+1,j,i)
+                sk_p(nzt+3,j,i)   = sk_p(nzt+1,j,i)
+             ENDDO
+          ENDDO
+
+       ELSEIF ( sk_char == 'e' )  THEN
+
+!
+!--       TKE boundary condition at bottom and top boundary (generally Neumann)
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                sk_p(nzb,j,i)   = sk_p(nzb+1,j,i)
+                sk_p(nzb-1,j,i) = sk_p(nzb,j,i)
+                sk_p(nzb-2,j,i) = sk_p(nzb,j,i)
+                sk_p(nzt+2,j,i) = sk_p(nzt+1,j,i)
+                sk_p(nzt+3,j,i) = sk_p(nzt+1,j,i)
+             ENDDO
+          ENDDO
+
+       ELSE
+
+          WRITE( message_string, * ) 'no vertical boundary condi',                &
+                                   'tion for variable "', sk_char, '"'
+          CALL message( 'advec_s_bc', 'PA0158', 1, 2, 0, 6, 0 )
+         
        ENDIF
 
-    ELSEIF ( sk_char == 'qr' )  THEN
-
-!
-!--    Rain water content boundary condition at the bottom boundary:
-!--    Dirichlet (fixed surface rain water content).
+!
+!--    Determine the maxima of the first and second derivative in z-direction
+       fmax_l = 0.0_wp
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             sk_p(nzb,j,i)   = sk_p(nzb+1,j,i)
-             sk_p(nzb-1,j,i) = sk_p(nzb,j,i)
-             sk_p(nzb-2,j,i) = sk_p(nzb,j,i)
+             DO  k = nzb, nzt+1
+                numera = ABS( sk_p(k+1,j,i) - 2.0_wp * sk_p(k,j,i) + sk_p(k-1,j,i) )
+                denomi  = ABS( sk_p(k+1,j,i+1) - sk_p(k-1,j,i) )
+                fmax_l(1) = MAX( fmax_l(1) , numera )
+                fmax_l(2) = MAX( fmax_l(2) , denomi  )
+             ENDDO
           ENDDO
        ENDDO
-
-!
-!--    Rain water content boundary condition at the top boundary: Dirichlet
+#if defined( __parallel )
+       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+       CALL MPI_ALLREDUCE( fmax_l, fmax, 2, MPI_REAL, MPI_MAX, comm2d, ierr )
+#else
+       fmax = fmax_l
+#endif
+
+       fmax = 0.04_wp * fmax
+
+!
+!--    Allocate temporary arrays
+       ALLOCATE( a0(nzb:nzt+1,nys:nyn),   a1(nzb:nzt+1,nys:nyn),                  &
+                 a2(nzb:nzt+1,nys:nyn),   a12(nzb:nzt+1,nys:nyn),                 &
+                 a22(nzb:nzt+1,nys:nyn),  immb(nzb+1:nzt,nys:nyn),                &
+                 imme(nzb+1:nzt,nys:nyn), impb(nzb+1:nzt,nys:nyn),                &
+                 impe(nzb+1:nzt,nys:nyn), ipmb(nzb+1:nzt,nys:nyn),                &
+                 ipme(nzb+1:nzt,nys:nyn), ippb(nzb+1:nzt,nys:nyn),                &
+                 ippe(nzb+1:nzt,nys:nyn), m1(nzb-1:nzt+2,nys:nyn),                &
+                 sw(nzb:nzt+1,nys:nyn)                                            &
+               )
+       imme = 0.0_wp; impe = 0.0_wp; ipme = 0.0_wp; ippe = 0.0_wp
+
+!
+!--    Outer loop of all i
+       DO  i = nxl, nxr
+
+!
+!--       Compute polynomial coefficients
+          DO  j = nys, nyn
+             DO  k = nzb, nzt+1
+                a12(k,j) = 0.5_wp * ( sk_p(k+1,j,i) - sk_p(k-1,j,i) )
+                a22(k,j) = 0.5_wp * ( sk_p(k+1,j,i) - 2.0_wp * sk_p(k,j,i)        &
+                                                    + sk_p(k-1,j,i) )
+                a0(k,j) = ( 9.0_wp * sk_p(k+2,j,i)    - 116.0_wp * sk_p(k+1,j,i)  &
+                            + 2134.0_wp * sk_p(k,j,i) - 116.0_wp * sk_p(k-1,j,i)  &
+                            + 9.0_wp * sk_p(k-2,j,i) ) * f1920
+                a1(k,j) = ( -5.0_wp   * sk_p(k+2,j,i) + 34.0_wp * sk_p(k+1,j,i)   &
+                            - 34.0_wp * sk_p(k-1,j,i) + 5.0_wp  * sk_p(k-2,j,i)   &
+                          ) * f48
+                a2(k,j) = ( -3.0_wp * sk_p(k+2,j,i) + 36.0_wp * sk_p(k+1,j,i)     &
+                            - 66.0_wp * sk_p(k,j,i) + 36.0_wp * sk_p(k-1,j,i)     &
+                            - 3.0_wp * sk_p(k-2,j,i) ) * f48
+             ENDDO
+          ENDDO
+
+!
+!--       Fluxes using the Bott scheme
+!--       *VOCL LOOP,UNROLL(2)
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+                cip  =  MAX( 0.0_wp, w(k,j,i) * dt_3d * ddzw(k) )
+                cim  = -MIN( 0.0_wp, w(k,j,i) * dt_3d * ddzw(k) )
+                cipf = 1.0_wp - 2.0_wp * cip
+                cimf = 1.0_wp - 2.0_wp * cim
+                ip   =   a0(k,j)   * f2  * ( 1.0_wp - cipf )                      &
+                       + a1(k,j)   * f8  * ( 1.0_wp - cipf*cipf )                 &
+                       + a2(k,j)   * f24 * ( 1.0_wp - cipf*cipf*cipf )
+                im   =   a0(k+1,j) * f2  * ( 1.0_wp - cimf )                      &
+                       - a1(k+1,j) * f8  * ( 1.0_wp - cimf*cimf )                 &
+                       + a2(k+1,j) * f24 * ( 1.0_wp - cimf*cimf*cimf )
+                ip   = MAX( ip, 0.0_wp )
+                im   = MAX( im, 0.0_wp )
+                ippb(k,j) = ip * MIN( 1.0_wp, sk_p(k,j,i)   / (ip+im+1E-15_wp) )
+                impb(k,j) = im * MIN( 1.0_wp, sk_p(k+1,j,i) / (ip+im+1E-15_wp) )
+
+                cip  =  MAX( 0.0_wp, w(k-1,j,i) * dt_3d * ddzw(k) )
+                cim  = -MIN( 0.0_wp, w(k-1,j,i) * dt_3d * ddzw(k) )
+                cipf = 1.0_wp - 2.0_wp * cip
+                cimf = 1.0_wp - 2.0_wp * cim
+                ip   =   a0(k-1,j) * f2  * ( 1.0_wp - cipf )                      &
+                       + a1(k-1,j) * f8  * ( 1.0_wp - cipf*cipf )                 &
+                       + a2(k-1,j) * f24 * ( 1.0_wp - cipf*cipf*cipf )
+                im   =   a0(k,j)   * f2  * ( 1.0_wp - cimf )                      &
+                       - a1(k,j)   * f8  * ( 1.0_wp - cimf*cimf )                 &
+                       + a2(k,j)   * f24 * ( 1.0_wp - cimf*cimf*cimf )
+                ip   = MAX( ip, 0.0_wp )
+                im   = MAX( im, 0.0_wp )
+                ipmb(k,j) = ip * MIN( 1.0_wp, sk_p(k-1,j,i) / (ip+im+1E-15_wp) )
+                immb(k,j) = im * MIN( 1.0_wp, sk_p(k,j,i)   / (ip+im+1E-15_wp) )
+             ENDDO
+          ENDDO
+
+!
+!--       Compute monitor function m1
+          DO  j = nys, nyn
+             DO  k = nzb-1, nzt+2
+                m1z = ABS( sk_p(k+1,j,i) - 2.0_wp * sk_p(k,j,i) + sk_p(k-1,j,i) )
+                m1n = ABS( sk_p(k+1,j,i) - sk_p(k-1,j,i) )
+                IF ( m1n /= 0.0_wp  .AND.  m1n >= m1z )  THEN
+                   m1(k,j) = m1z / m1n
+                   IF ( m1(k,j) /= 2.0_wp  .AND.  m1n < fmax(2) )  m1(k,j) = 0.0_wp
+                ELSEIF ( m1n < m1z )  THEN
+                   m1(k,j) = -1.0_wp
+                ELSE
+                   m1(k,j) = 0.0_wp
+                ENDIF
+             ENDDO
+          ENDDO
+
+!
+!--       Compute switch sw
+          sw = 0.0_wp
+          DO  j = nys, nyn
+             DO  k = nzb, nzt+1
+                m2 = 2.0_wp * ABS( a1(k,j) - a12(k,j) ) /                         &
+                     MAX( ABS( a1(k,j) + a12(k,j) ), 1E-35_wp )
+                IF ( ABS( a1(k,j) + a12(k,j) ) < fmax(2) )  m2 = 0.0_wp
+
+                m3 = 2.0_wp * ABS( a2(k,j) - a22(k,j) ) /                         &
+                     MAX( ABS( a2(k,j) + a22(k,j) ), 1E-35_wp )
+                IF ( ABS( a2(k,j) + a22(k,j) ) < fmax(1) )  m3 = 0.0_wp
+
+                t1 = 0.35_wp
+                t2 = 0.35_wp
+                IF ( m1(k,j) == -1.0_wp )  t2 = 0.12_wp
+
+!--             *VOCL STMT,IF(10)
+                IF ( m1(k-1,j) == 1.0_wp .OR. m1(k,j) == 1.0_wp                   &
+                     .OR. m1(k+1,j) == 1.0_wp .OR.  m2 > t2  .OR.  m3 > t2  .OR.  &
+                     ( m1(k,j) > t1  .AND.  m1(k-1,j) /= -1.0_wp  .AND.           &
+                       m1(k,j) /= -1.0_wp  .AND.  m1(k+1,j) /= -1.0_wp )          &
+                   )  sw(k,j) = 1.0_wp
+             ENDDO
+          ENDDO
+
+!
+!--       Fluxes using exponential scheme
+          CALL cpu_log( log_point_s(12), 'advec_s_bc:exp', 'continue' )
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+
+!--             *VOCL STMT,IF(10)
+                IF ( sw(k,j) == 1.0_wp )  THEN
+                   snenn = sk_p(k+1,j,i) - sk_p(k-1,j,i)
+                   IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
+                   sterm = ( sk_p(k,j,i) - sk_p(k-1,j,i) ) / snenn
+                   sterm = MIN( sterm, 0.9999_wp )
+                   sterm = MAX( sterm, 0.0001_wp )
+
+                   ix = INT( sterm * 1000 ) + 1
+
+                   cip =  MAX( 0.0_wp, w(k,j,i) * dt_3d * ddzw(k) )
+
+                   ippe(k,j) = sk_p(k-1,j,i) * cip + snenn * (                    &
+                               aex(ix) * cip + bex(ix) / dex(ix) * (              &
+                               eex(ix) -                                          &
+                               EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cip ) )  &
+                                                                   )              &
+                                                             )
+                   IF ( sterm == 0.0001_wp )  ippe(k,j) = sk_p(k,j,i) * cip
+                   IF ( sterm == 0.9999_wp )  ippe(k,j) = sk_p(k,j,i) * cip
+
+                   snenn = sk_p(k-1,j,i) - sk_p(k+1,j,i)
+                   IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
+                   sterm = ( sk_p(k,j,i) - sk_p(k+1,j,i) ) / snenn
+                   sterm = MIN( sterm, 0.9999_wp )
+                   sterm = MAX( sterm, 0.0001_wp )
+
+                   ix = INT( sterm * 1000 ) + 1
+
+                   cim = -MIN( 0.0_wp, w(k-1,j,i) * dt_3d * ddzw(k) )
+
+                   imme(k,j) = sk_p(k+1,j,i) * cim + snenn * (                    &
+                               aex(ix) * cim + bex(ix) / dex(ix) * (              &
+                               eex(ix) -                                          &
+                               EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cim ) ) &
+                                                                   )              &
+                                                             )
+                   IF ( sterm == 0.0001_wp )  imme(k,j) = sk_p(k,j,i) * cim
+                   IF ( sterm == 0.9999_wp )  imme(k,j) = sk_p(k,j,i) * cim
+                ENDIF
+
+!--             *VOCL STMT,IF(10)
+                IF ( sw(k+1,j) == 1.0_wp )  THEN
+                   snenn = sk_p(k,j,i) - sk_p(k+2,j,i)
+                   IF ( ABS( snenn ) .LT. 1E-9_wp )  snenn = 1E-9_wp
+                   sterm = ( sk_p(k+1,j,i) - sk_p(k+2,j,i) ) / snenn
+                   sterm = MIN( sterm, 0.9999_wp )
+                   sterm = MAX( sterm, 0.0001_wp )
+
+                   ix = INT( sterm * 1000 ) + 1
+
+                   cim = -MIN( 0.0_wp, w(k,j,i) * dt_3d * ddzw(k) )
+
+                   impe(k,j) = sk_p(k+2,j,i) * cim + snenn * (                    &
+                               aex(ix) * cim + bex(ix) / dex(ix) * (              &
+                               eex(ix) -                                          &
+                               EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cim ) )  &
+                                                                   )              &
+                                                             )
+                   IF ( sterm == 0.0001_wp )  impe(k,j) = sk_p(k+1,j,i) * cim
+                   IF ( sterm == 0.9999_wp )  impe(k,j) = sk_p(k+1,j,i) * cim
+                ENDIF
+
+!--             *VOCL STMT,IF(10)
+                IF ( sw(k-1,j) == 1.0_wp )  THEN
+                   snenn = sk_p(k,j,i) - sk_p(k-2,j,i)
+                   IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
+                   sterm = ( sk_p(k-1,j,i) - sk_p(k-2,j,i) ) / snenn
+                   sterm = MIN( sterm, 0.9999_wp )
+                   sterm = MAX( sterm, 0.0001_wp )
+
+                   ix = INT( sterm * 1000 ) + 1
+
+                   cip = MAX( 0.0_wp, w(k-1,j,i) * dt_3d * ddzw(k) )
+
+                   ipme(k,j) = sk_p(k-2,j,i) * cip + snenn * (                    &
+                               aex(ix) * cip + bex(ix) / dex(ix) * (              &
+                               eex(ix) -                                          &
+                               EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cip ) )  &
+                                                                   )              &
+                                                             )
+                   IF ( sterm == 0.0001_wp )  ipme(k,j) = sk_p(k-1,j,i) * cip
+                   IF ( sterm == 0.9999_wp )  ipme(k,j) = sk_p(k-1,j,i) * cip
+                ENDIF
+
+             ENDDO
+          ENDDO
+          CALL cpu_log( log_point_s(12), 'advec_s_bc:exp', 'pause' )
+
+!
+!--       Prognostic equation
+          DO  j = nys, nyn
+             DO  k = nzb+1, nzt
+                fplus  = ( 1.0_wp - sw(k,j)   ) * ippb(k,j) + sw(k,j)   * ippe(k,j) &
+                       - ( 1.0_wp - sw(k+1,j) ) * impb(k,j) - sw(k+1,j) * impe(k,j)
+                fminus = ( 1.0_wp - sw(k-1,j) ) * ipmb(k,j) + sw(k-1,j) * ipme(k,j) &
+                       - ( 1.0_wp - sw(k,j)   ) * immb(k,j) - sw(k,j)   * imme(k,j)
+                tendcy = fplus - fminus
+!
+!--              Removed in order to optimise speed
+!                ffmax   = MAX( ABS( fplus ), ABS( fminus ), 1E-35_wp )
+!                IF ( ( ABS( tendcy ) / ffmax ) < 1E-7_wp )  tendcy = 0.0
+!
+!--             Density correction because of possible remaining divergences
+                d_new = d(k,j,i) - ( w(k,j,i) - w(k-1,j,i) ) * dt_3d * ddzw(k)
+                sk_p(k,j,i) = ( ( 1.0_wp + d(k,j,i) ) * sk_p(k,j,i) - tendcy ) /  &
+                              ( 1.0_wp + d_new )
+!
+!--             Store heat flux for subsequent statistics output.
+!--             array m1 is here used as temporary storage
+                m1(k,j) = fplus / dt_3d * dzw(k)
+             ENDDO
+          ENDDO
+
+!
+!--       Sum up heat flux in order to order to obtain horizontal averages
+          IF ( sk_char == 'pt' )  THEN
+             DO  sr = 0, statistic_regions
+                DO  j = nys, nyn
+                   DO  k = nzb+1, nzt
+                      sums_wsts_bc_l(k,sr) = sums_wsts_bc_l(k,sr) +               &
+                                             m1(k,j) * rmask(j,i,sr)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDIF
+
+       ENDDO   ! End of the advection in z-direction
+       CALL cpu_log( log_point_s(12), 'advec_s_bc:exp', 'continue' )
+       CALL cpu_log( log_point_s(12), 'advec_s_bc:exp', 'stop' )
+
+!
+!--    Deallocate temporary arrays
+       DEALLOCATE( a0, a1, a2, a12, a22, immb, imme, impb, impe, ipmb, ipme,      &
+                   ippb, ippe, m1, sw )
+
+!
+!--    Store results as tendency and deallocate local array
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             sk_p(nzt+2,j,i)   = sk_p(nzt+1,j,i)
-             sk_p(nzt+3,j,i)   = sk_p(nzt+1,j,i)
+             DO  k = nzb+1, nzt
+                tend(k,j,i) = tend(k,j,i) + ( sk_p(k,j,i) - sk(k,j,i) ) / dt_3d
+             ENDDO
           ENDDO
        ENDDO
 
-    ELSEIF ( sk_char == 'nr' )  THEN
-
-!
-!--    Rain drop concentration boundary condition at the bottom boundary:
-!--    Dirichlet (fixed surface rain drop concentration).
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             sk_p(nzb,j,i)   = sk_p(nzb+1,j,i)
-             sk_p(nzb-1,j,i) = sk_p(nzb,j,i)
-             sk_p(nzb-2,j,i) = sk_p(nzb,j,i)
-          ENDDO
-       ENDDO
-
-!
-!--    Rain drop concentration boundary condition at the top boundary: Dirichlet
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             sk_p(nzt+2,j,i)   = sk_p(nzt+1,j,i)
-             sk_p(nzt+3,j,i)   = sk_p(nzt+1,j,i)
-          ENDDO
-       ENDDO
-
-    ELSEIF ( sk_char == 'e' )  THEN
-
-!
-!--    TKE boundary condition at bottom and top boundary (generally Neumann)
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             sk_p(nzb,j,i)   = sk_p(nzb+1,j,i)
-             sk_p(nzb-1,j,i) = sk_p(nzb,j,i)
-             sk_p(nzb-2,j,i) = sk_p(nzb,j,i)
-             sk_p(nzt+2,j,i) = sk_p(nzt+1,j,i)
-             sk_p(nzt+3,j,i) = sk_p(nzt+1,j,i)
-          ENDDO
-       ENDDO
-
-    ELSE
-
-       WRITE( message_string, * ) 'no vertical boundary condi',                &
-                                'tion for variable "', sk_char, '"'
-       CALL message( 'advec_s_bc', 'PA0158', 1, 2, 0, 6, 0 )
-      
-    ENDIF
-
-!
-!-- Determine the maxima of the first and second derivative in z-direction
-    fmax_l = 0.0_wp
-    DO  i = nxl, nxr
-       DO  j = nys, nyn
-          DO  k = nzb, nzt+1
-             numera = ABS( sk_p(k+1,j,i) - 2.0_wp * sk_p(k,j,i) + sk_p(k-1,j,i) )
-             denomi  = ABS( sk_p(k+1,j,i+1) - sk_p(k-1,j,i) )
-             fmax_l(1) = MAX( fmax_l(1) , numera )
-             fmax_l(2) = MAX( fmax_l(2) , denomi  )
-          ENDDO
-       ENDDO
-    ENDDO
-#if defined( __parallel )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( fmax_l, fmax, 2, MPI_REAL, MPI_MAX, comm2d, ierr )
-#else
-    fmax = fmax_l
-#endif
-
-    fmax = 0.04_wp * fmax
-
-!
-!-- Allocate temporary arrays
-    ALLOCATE( a0(nzb:nzt+1,nys:nyn),   a1(nzb:nzt+1,nys:nyn),                  &
-              a2(nzb:nzt+1,nys:nyn),   a12(nzb:nzt+1,nys:nyn),                 &
-              a22(nzb:nzt+1,nys:nyn),  immb(nzb+1:nzt,nys:nyn),                &
-              imme(nzb+1:nzt,nys:nyn), impb(nzb+1:nzt,nys:nyn),                &
-              impe(nzb+1:nzt,nys:nyn), ipmb(nzb+1:nzt,nys:nyn),                &
-              ipme(nzb+1:nzt,nys:nyn), ippb(nzb+1:nzt,nys:nyn),                &
-              ippe(nzb+1:nzt,nys:nyn), m1(nzb-1:nzt+2,nys:nyn),                &
-              sw(nzb:nzt+1,nys:nyn)                                            &
-            )
-    imme = 0.0_wp; impe = 0.0_wp; ipme = 0.0_wp; ippe = 0.0_wp
-
-!
-!-- Outer loop of all i
-    DO  i = nxl, nxr
-
-!
-!--    Compute polynomial coefficients
-       DO  j = nys, nyn
-          DO  k = nzb, nzt+1
-             a12(k,j) = 0.5_wp * ( sk_p(k+1,j,i) - sk_p(k-1,j,i) )
-             a22(k,j) = 0.5_wp * ( sk_p(k+1,j,i) - 2.0_wp * sk_p(k,j,i)        &
-                                                 + sk_p(k-1,j,i) )
-             a0(k,j) = ( 9.0_wp * sk_p(k+2,j,i)    - 116.0_wp * sk_p(k+1,j,i)  &
-                         + 2134.0_wp * sk_p(k,j,i) - 116.0_wp * sk_p(k-1,j,i)  &
-                         + 9.0_wp * sk_p(k-2,j,i) ) * f1920
-             a1(k,j) = ( -5.0_wp   * sk_p(k+2,j,i) + 34.0_wp * sk_p(k+1,j,i)   &
-                         - 34.0_wp * sk_p(k-1,j,i) + 5.0_wp  * sk_p(k-2,j,i)   &
-                       ) * f48
-             a2(k,j) = ( -3.0_wp * sk_p(k+2,j,i) + 36.0_wp * sk_p(k+1,j,i)     &
-                         - 66.0_wp * sk_p(k,j,i) + 36.0_wp * sk_p(k-1,j,i)     &
-                         - 3.0_wp * sk_p(k-2,j,i) ) * f48
-          ENDDO
-       ENDDO
-
-!
-!--    Fluxes using the Bott scheme
-!--    *VOCL LOOP,UNROLL(2)
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt
-             cip  =  MAX( 0.0_wp, w(k,j,i) * dt_3d * ddzw(k) )
-             cim  = -MIN( 0.0_wp, w(k,j,i) * dt_3d * ddzw(k) )
-             cipf = 1.0_wp - 2.0_wp * cip
-             cimf = 1.0_wp - 2.0_wp * cim
-             ip   =   a0(k,j)   * f2  * ( 1.0_wp - cipf )                      &
-                    + a1(k,j)   * f8  * ( 1.0_wp - cipf*cipf )                 &
-                    + a2(k,j)   * f24 * ( 1.0_wp - cipf*cipf*cipf )
-             im   =   a0(k+1,j) * f2  * ( 1.0_wp - cimf )                      &
-                    - a1(k+1,j) * f8  * ( 1.0_wp - cimf*cimf )                 &
-                    + a2(k+1,j) * f24 * ( 1.0_wp - cimf*cimf*cimf )
-             ip   = MAX( ip, 0.0_wp )
-             im   = MAX( im, 0.0_wp )
-             ippb(k,j) = ip * MIN( 1.0_wp, sk_p(k,j,i)   / (ip+im+1E-15_wp) )
-             impb(k,j) = im * MIN( 1.0_wp, sk_p(k+1,j,i) / (ip+im+1E-15_wp) )
-
-             cip  =  MAX( 0.0_wp, w(k-1,j,i) * dt_3d * ddzw(k) )
-             cim  = -MIN( 0.0_wp, w(k-1,j,i) * dt_3d * ddzw(k) )
-             cipf = 1.0_wp - 2.0_wp * cip
-             cimf = 1.0_wp - 2.0_wp * cim
-             ip   =   a0(k-1,j) * f2  * ( 1.0_wp - cipf )                      &
-                    + a1(k-1,j) * f8  * ( 1.0_wp - cipf*cipf )                 &
-                    + a2(k-1,j) * f24 * ( 1.0_wp - cipf*cipf*cipf )
-             im   =   a0(k,j)   * f2  * ( 1.0_wp - cimf )                      &
-                    - a1(k,j)   * f8  * ( 1.0_wp - cimf*cimf )                 &
-                    + a2(k,j)   * f24 * ( 1.0_wp - cimf*cimf*cimf )
-             ip   = MAX( ip, 0.0_wp )
-             im   = MAX( im, 0.0_wp )
-             ipmb(k,j) = ip * MIN( 1.0_wp, sk_p(k-1,j,i) / (ip+im+1E-15_wp) )
-             immb(k,j) = im * MIN( 1.0_wp, sk_p(k,j,i)   / (ip+im+1E-15_wp) )
-          ENDDO
-       ENDDO
-
-!
-!--    Compute monitor function m1
-       DO  j = nys, nyn
-          DO  k = nzb-1, nzt+2
-             m1z = ABS( sk_p(k+1,j,i) - 2.0_wp * sk_p(k,j,i) + sk_p(k-1,j,i) )
-             m1n = ABS( sk_p(k+1,j,i) - sk_p(k-1,j,i) )
-             IF ( m1n /= 0.0_wp  .AND.  m1n >= m1z )  THEN
-                m1(k,j) = m1z / m1n
-                IF ( m1(k,j) /= 2.0_wp  .AND.  m1n < fmax(2) )  m1(k,j) = 0.0_wp
-             ELSEIF ( m1n < m1z )  THEN
-                m1(k,j) = -1.0_wp
-             ELSE
-                m1(k,j) = 0.0_wp
-             ENDIF
-          ENDDO
-       ENDDO
-
-!
-!--    Compute switch sw
-       sw = 0.0_wp
-       DO  j = nys, nyn
-          DO  k = nzb, nzt+1
-             m2 = 2.0_wp * ABS( a1(k,j) - a12(k,j) ) /                         &
-                  MAX( ABS( a1(k,j) + a12(k,j) ), 1E-35_wp )
-             IF ( ABS( a1(k,j) + a12(k,j) ) < fmax(2) )  m2 = 0.0_wp
-
-             m3 = 2.0_wp * ABS( a2(k,j) - a22(k,j) ) /                         &
-                  MAX( ABS( a2(k,j) + a22(k,j) ), 1E-35_wp )
-             IF ( ABS( a2(k,j) + a22(k,j) ) < fmax(1) )  m3 = 0.0_wp
-
-             t1 = 0.35_wp
-             t2 = 0.35_wp
-             IF ( m1(k,j) == -1.0_wp )  t2 = 0.12_wp
-
-!--          *VOCL STMT,IF(10)
-             IF ( m1(k-1,j) == 1.0_wp .OR. m1(k,j) == 1.0_wp                   &
-                  .OR. m1(k+1,j) == 1.0_wp .OR.  m2 > t2  .OR.  m3 > t2  .OR.  &
-                  ( m1(k,j) > t1  .AND.  m1(k-1,j) /= -1.0_wp  .AND.           &
-                    m1(k,j) /= -1.0_wp  .AND.  m1(k+1,j) /= -1.0_wp )          &
-                )  sw(k,j) = 1.0_wp
-          ENDDO
-       ENDDO
-
-!
-!--    Fluxes using exponential scheme
-       CALL cpu_log( log_point_s(12), 'advec_s_bc:exp', 'continue' )
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt
-
-!--          *VOCL STMT,IF(10)
-             IF ( sw(k,j) == 1.0_wp )  THEN
-                snenn = sk_p(k+1,j,i) - sk_p(k-1,j,i)
-                IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
-                sterm = ( sk_p(k,j,i) - sk_p(k-1,j,i) ) / snenn
-                sterm = MIN( sterm, 0.9999_wp )
-                sterm = MAX( sterm, 0.0001_wp )
-
-                ix = INT( sterm * 1000 ) + 1
-
-                cip =  MAX( 0.0_wp, w(k,j,i) * dt_3d * ddzw(k) )
-
-                ippe(k,j) = sk_p(k-1,j,i) * cip + snenn * (                    &
-                            aex(ix) * cip + bex(ix) / dex(ix) * (              &
-                            eex(ix) -                                          &
-                            EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cip ) )  &
-                                                                )              &
-                                                          )
-                IF ( sterm == 0.0001_wp )  ippe(k,j) = sk_p(k,j,i) * cip
-                IF ( sterm == 0.9999_wp )  ippe(k,j) = sk_p(k,j,i) * cip
-
-                snenn = sk_p(k-1,j,i) - sk_p(k+1,j,i)
-                IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
-                sterm = ( sk_p(k,j,i) - sk_p(k+1,j,i) ) / snenn
-                sterm = MIN( sterm, 0.9999_wp )
-                sterm = MAX( sterm, 0.0001_wp )
-
-                ix = INT( sterm * 1000 ) + 1
-
-                cim = -MIN( 0.0_wp, w(k-1,j,i) * dt_3d * ddzw(k) )
-
-                imme(k,j) = sk_p(k+1,j,i) * cim + snenn * (                    &
-                            aex(ix) * cim + bex(ix) / dex(ix) * (              &
-                            eex(ix) -                                          &
-                            EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cim ) ) &
-                                                                )              &
-                                                          )
-                IF ( sterm == 0.0001_wp )  imme(k,j) = sk_p(k,j,i) * cim
-                IF ( sterm == 0.9999_wp )  imme(k,j) = sk_p(k,j,i) * cim
-             ENDIF
-
-!--          *VOCL STMT,IF(10)
-             IF ( sw(k+1,j) == 1.0_wp )  THEN
-                snenn = sk_p(k,j,i) - sk_p(k+2,j,i)
-                IF ( ABS( snenn ) .LT. 1E-9_wp )  snenn = 1E-9_wp
-                sterm = ( sk_p(k+1,j,i) - sk_p(k+2,j,i) ) / snenn
-                sterm = MIN( sterm, 0.9999_wp )
-                sterm = MAX( sterm, 0.0001_wp )
-
-                ix = INT( sterm * 1000 ) + 1
-
-                cim = -MIN( 0.0_wp, w(k,j,i) * dt_3d * ddzw(k) )
-
-                impe(k,j) = sk_p(k+2,j,i) * cim + snenn * (                    &
-                            aex(ix) * cim + bex(ix) / dex(ix) * (              &
-                            eex(ix) -                                          &
-                            EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cim ) )  &
-                                                                )              &
-                                                          )
-                IF ( sterm == 0.0001_wp )  impe(k,j) = sk_p(k+1,j,i) * cim
-                IF ( sterm == 0.9999_wp )  impe(k,j) = sk_p(k+1,j,i) * cim
-             ENDIF
-
-!--          *VOCL STMT,IF(10)
-             IF ( sw(k-1,j) == 1.0_wp )  THEN
-                snenn = sk_p(k,j,i) - sk_p(k-2,j,i)
-                IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
-                sterm = ( sk_p(k-1,j,i) - sk_p(k-2,j,i) ) / snenn
-                sterm = MIN( sterm, 0.9999_wp )
-                sterm = MAX( sterm, 0.0001_wp )
-
-                ix = INT( sterm * 1000 ) + 1
-
-                cip = MAX( 0.0_wp, w(k-1,j,i) * dt_3d * ddzw(k) )
-
-                ipme(k,j) = sk_p(k-2,j,i) * cip + snenn * (                    &
-                            aex(ix) * cip + bex(ix) / dex(ix) * (              &
-                            eex(ix) -                                          &
-                            EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cip ) )  &
-                                                                )              &
-                                                          )
-                IF ( sterm == 0.0001_wp )  ipme(k,j) = sk_p(k-1,j,i) * cip
-                IF ( sterm == 0.9999_wp )  ipme(k,j) = sk_p(k-1,j,i) * cip
-             ENDIF
-
-          ENDDO
-       ENDDO
-       CALL cpu_log( log_point_s(12), 'advec_s_bc:exp', 'pause' )
-
-!
-!--    Prognostic equation
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt
-             fplus  = ( 1.0_wp - sw(k,j)   ) * ippb(k,j) + sw(k,j)   * ippe(k,j) &
-                    - ( 1.0_wp - sw(k+1,j) ) * impb(k,j) - sw(k+1,j) * impe(k,j)
-             fminus = ( 1.0_wp - sw(k-1,j) ) * ipmb(k,j) + sw(k-1,j) * ipme(k,j) &
-                    - ( 1.0_wp - sw(k,j)   ) * immb(k,j) - sw(k,j)   * imme(k,j)
-             tendcy = fplus - fminus
-!
-!--           Removed in order to optimise speed
-!             ffmax   = MAX( ABS( fplus ), ABS( fminus ), 1E-35_wp )
-!             IF ( ( ABS( tendcy ) / ffmax ) < 1E-7_wp )  tendcy = 0.0
-!
-!--          Density correction because of possible remaining divergences
-             d_new = d(k,j,i) - ( w(k,j,i) - w(k-1,j,i) ) * dt_3d * ddzw(k)
-             sk_p(k,j,i) = ( ( 1.0_wp + d(k,j,i) ) * sk_p(k,j,i) - tendcy ) /  &
-                           ( 1.0_wp + d_new )
-!
-!--          Store heat flux for subsequent statistics output.
-!--          array m1 is here used as temporary storage
-             m1(k,j) = fplus / dt_3d * dzw(k)
-          ENDDO
-       ENDDO
-
-!
-!--    Sum up heat flux in order to order to obtain horizontal averages
-       IF ( sk_char == 'pt' )  THEN
-          DO  sr = 0, statistic_regions
-             DO  j = nys, nyn
-                DO  k = nzb+1, nzt
-                   sums_wsts_bc_l(k,sr) = sums_wsts_bc_l(k,sr) +               &
-                                          m1(k,j) * rmask(j,i,sr)
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-
-    ENDDO   ! End of the advection in z-direction
-    CALL cpu_log( log_point_s(12), 'advec_s_bc:exp', 'continue' )
-    CALL cpu_log( log_point_s(12), 'advec_s_bc:exp', 'stop' )
-
-!
-!-- Deallocate temporary arrays
-    DEALLOCATE( a0, a1, a2, a12, a22, immb, imme, impb, impe, ipmb, ipme,      &
-                ippb, ippe, m1, sw )
-
-!
-!-- Store results as tendency and deallocate local array
-    DO  i = nxl, nxr
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt
-             tend(k,j,i) = tend(k,j,i) + ( sk_p(k,j,i) - sk(k,j,i) ) / dt_3d
-          ENDDO
-       ENDDO
-    ENDDO
-
-    DEALLOCATE( sk_p )
-
- END SUBROUTINE advec_s_bc
+       DEALLOCATE( sk_p )
+
+    END SUBROUTINE advec_s_bc
+
+ END MODULE advec_s_bc_mod
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1516)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1517)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! advec_s_bc_mod addded, since advec_s_bc is now a module
 ! 
 ! Former revisions:
@@ -200,4 +200,7 @@
                advec_v_ws, advec_v_ws_acc, advec_w_ws, advec_w_ws_acc
 
+    USE advec_s_bc_mod,                                                        &
+        ONLY:  advec_s_bc
+
     USE advec_s_pw_mod,                                                        &
         ONLY:  advec_s_pw
